#[derive(Debug, PartialEq, Clone, Copy)]
pub enum Contraption {
    Empty,
    MirrorLeft,
    MirrorRight,
    SplitterVert,
    SplitterHoriz,
}

#[derive(Debug, PartialEq, Clone, Copy, Eq, Hash)]
pub enum Direction {
    Up,
    Down,
    Left,
    Right,
}

#[allow(dead_code)]
pub fn print_contraption(contraption: &Vec<Vec<Contraption>>) {
    for row in contraption {
        for c in row {
            match c {
                Contraption::Empty => print!("."),
                Contraption::MirrorLeft => print!("\\"),
                Contraption::MirrorRight => print!("/"),
                Contraption::SplitterVert => print!("|"),
                Contraption::SplitterHoriz => print!("-"),
            }
        }
        println!();
    }
}

#[allow(dead_code)]
pub fn print_energized(contraption: &Vec<Vec<bool>>) {
    for row in contraption {
        for c in row {
            if *c {
                print!("#");
            } else {
                print!(".");
            }
        }
        println!();
    }
}